import java.applet.Applet;
import java.applet.AudioClip;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.Label;
import java.awt.Panel;
import java.util.Date;
import java.util.StringTokenizer;

public class Clock1 extends Applet implements Runnable {
   // $FF: renamed from: as AppletSettings
   AppletSettings field_0;
   AudioClip alarmsound;
   AudioClip hsound;
   AudioClip msound;
   Date alarmtime;
   DetachFrame dframe;
   Thread woohoo;
   boolean countdown = false;
   boolean pagedestroyed = false;
   boolean twentyfour = false;
   String timestring;
   String timeformat;
   String cmessage;
   int tzoffset = -100;
   int hint = -1;
   int mint = -1;
   long ctime;
   // $FF: renamed from: l java.awt.Label
   Label field_1 = new Label("", 1);
   Panel mainpanel = new Panel();

   public void stop() {
      ((Container)this).removeAll();
      this.woohoo.stop();
      this.woohoo = null;
   }

   public void destroy() {
      this.pagedestroyed = true;
   }

   public void init() {
      this.mainpanel.setLayout(new BorderLayout(0, 0));
      this.dframe = new DetachFrame(this, this.mainpanel);
      this.dframe.setTitle("Digital Clock applet");
   }

   public void start() {
      this.field_0 = new AppletSettings(this);
      Object var1 = null;
      String var13 = ((Applet)this).getParameter("COPYRIGHT");
      if (var13 == null || !var13.equals("Clock applet, Copyright 1996 Sun Microsystems, Inc., all rights reserved.")) {
         this.stop();
      }

      var13 = ((Applet)this).getParameter("DOCUMENTATION");
      if (var13 == null || !var13.equals("Documentation found at: http://www.xm.com/cafe/")) {
         this.stop();
      }

      var13 = ((Applet)this).getParameter("COUNTDOWN.TIME");
      if (var13 != null) {
         this.countdown = true;
         StringTokenizer var2 = new StringTokenizer(var13, ",");
         int var3 = Integer.parseInt(var2.nextToken());
         int var4 = Integer.parseInt(var2.nextToken());
         int var5 = Integer.parseInt(var2.nextToken());
         int var6 = Integer.parseInt(var2.nextToken());
         int var7 = Integer.parseInt(var2.nextToken());
         int var8 = Integer.parseInt(var2.nextToken());
         Date var9 = new Date(var3, var4, var5, var6, var7, var8);
         this.ctime = var9.getTime();
         var13 = ((Applet)this).getParameter("COUNTDOWN.BEFORE");
         this.timestring = var13 == null ? "Countdown: %day;, %hour;:%minute;:%second;" : var13;
         var13 = ((Applet)this).getParameter("COUNTDOWN.AFTER");
         this.cmessage = var13 == null ? "Your time passed %day; days, %hour; hours, %minute; minutes, and %second; seconds ago." : var13;
      }

      var13 = ((Applet)this).getParameter("ALARM.TIME");
      if (var13 != null) {
         StringTokenizer var27 = new StringTokenizer(var13, ",");
         int var28 = Integer.parseInt(var27.nextToken());
         int var29 = Integer.parseInt(var27.nextToken());
         int var30 = Integer.parseInt(var27.nextToken());
         int var31 = Integer.parseInt(var27.nextToken());
         int var32 = Integer.parseInt(var27.nextToken());
         int var33 = Integer.parseInt(var27.nextToken());
         this.alarmtime = new Date(var28, var29, var30, var31, var32, var33);
      }

      var13 = ((Applet)this).getParameter("ALARM.SOUND");
      if (var13 != null) {
         try {
            this.alarmsound = ((Applet)this).getAudioClip(((Applet)this).getDocumentBase(), var13);
         } catch (Exception var12) {
         }
      }

      var13 = ((Applet)this).getParameter("HOUR.SOUND");
      if (var13 != null) {
         try {
            this.hsound = ((Applet)this).getAudioClip(((Applet)this).getDocumentBase(), var13);
         } catch (Exception var11) {
         }
      }

      var13 = ((Applet)this).getParameter("MINUTE.SOUND");
      if (var13 != null) {
         try {
            this.msound = ((Applet)this).getAudioClip(((Applet)this).getDocumentBase(), var13);
         } catch (Exception var10) {
         }
      }

      var13 = ((Applet)this).getParameter("CHIME.MINUTE");
      if (var13 != null) {
         this.mint = Integer.parseInt(var13);
      }

      var13 = ((Applet)this).getParameter("CHIME.HOUR");
      if (var13 != null) {
         this.hint = Integer.parseInt(var13);
      }

      var13 = ((Applet)this).getParameter("TIMEZONE");
      if (var13 != null) {
         this.tzoffset = Integer.parseInt(var13);
      }

      var13 = ((Applet)this).getParameter("24HOUR");
      if (var13 == null || var13.equalsIgnoreCase("yes") || var13.equalsIgnoreCase("true") || var13.equalsIgnoreCase("on")) {
         this.twentyfour = true;
      }

      var13 = ((Applet)this).getParameter("TIME.DISPLAY");
      this.timeformat = var13 == null ? "%date;/%month;/%year; %hour;:%minute;:%second;" : var13;
      ((Container)this).setLayout(new BorderLayout(0, 0));
      ((Component)this).setBackground(this.field_0.bgcolor);
      this.field_1.setBackground(this.field_0.bgcolor);
      this.field_1.setForeground(this.field_0.textcolor);
      this.field_1.setFont(new Font(this.field_0.fontname, this.field_0.fontstyle, this.field_0.fontsize));
      this.mainpanel.add("Center", this.field_1);
      ((Container)this).add("Center", this.mainpanel);
      if (this.woohoo == null) {
         this.woohoo = new Thread(this);
      }

      this.woohoo.start();
   }

   public void run() {
      boolean var1 = true;

      while(var1) {
         Date var2 = new Date();
         int var3 = this.tzoffset != -100 ? var2.getHours() + var2.getTimezoneOffset() / 60 + this.tzoffset : var2.getHours();
         Date var4 = new Date(var2.getYear(), var2.getMonth(), var2.getDate(), var3, var2.getMinutes(), var2.getSeconds());
         if (!this.countdown) {
            if (var4.equals(this.alarmtime) && this.alarmsound != null) {
               this.alarmsound.play();
            }

            if (this.mint == var4.getMinutes() && var4.getSeconds() == 0 && this.msound != null) {
               this.msound.play();
            }

            if (this.hint == var4.getHours() && var4.getMinutes() + var4.getSeconds() == 0 && this.hsound != null) {
               this.hsound.play();
            }

            String var5 = this.timeformat;
            var5 = this.replace(var5, "%date;", this.pad(var4.getDate()));
            var5 = this.replace(var5, "%year;", this.pad(var4.getYear()));
            var5 = this.replace(var5, "%month;", this.pad(var4.getMonth() + 1));
            var5 = this.replace(var5, "%minute;", this.pad(var4.getMinutes()));
            var5 = this.replace(var5, "%second;", this.pad(var4.getSeconds()));
            if (!this.twentyfour) {
               int var6 = var4.getHours();
               var5 = var6 > 11 ? this.replace(var5, "%ampm;", "pm") : this.replace(var5, "%ampm;", "am");
               var5 = var6 > 11 ? this.replace(var5, "%AMPM;", "PM") : this.replace(var5, "%AMPM;", "AM");
               var6 = (var6 + 11) % 12 + 1;
               var5 = this.replace(var5, "%hour;", String.valueOf(var6));
            } else {
               var5 = this.replace(var5, "%ampm;", "");
               var5 = this.replace(var5, "%AMPM;", "");
               var5 = this.replace(var5, "%hour;", this.pad(var4.getHours()));
            }

            this.field_1.setText(var5);
         } else {
            long var25 = var4.getTime();
            long var7 = Math.abs(this.ctime - var25);
            int var9 = (int)(var7 / 86400000L);
            var7 %= 86400000L;
            int var10 = (int)(var7 / 3600000L);
            var7 %= 3600000L;
            int var11 = (int)(var7 / 60000L);
            var7 %= 60000L;
            int var12 = (int)(var7 / 1000L);
            var7 %= 1000L;
            String var13 = this.ctime - var25 < 0L ? this.cmessage : this.timestring;
            var13 = this.replace(var13, "%day;", String.valueOf(var9));
            var13 = this.replace(var13, "%hour;", this.pad(var10));
            var13 = this.replace(var13, "%minute;", this.pad(var11));
            var13 = this.replace(var13, "%second;", this.pad(var12));
            if (var9 + var10 + var11 + var12 == 0 && this.alarmsound != null) {
               this.alarmsound.play();
            } else {
               this.field_1.setText(var13);
            }
         }

         try {
            Thread.sleep(1000L);
         } catch (Exception var14) {
            System.out.println(((Throwable)var14).toString());
         }
      }

   }

   public String replace(String var1, String var2, String var3) {
      if (var1.indexOf(var2) == -1) {
         return var1;
      } else {
         String var4 = var1.substring(0, var1.indexOf(var2));
         String var5 = var1.substring(var1.indexOf(var2) + var2.length());
         return var4 + var3 + var5;
      }
   }

   public boolean handleEvent(Event var1) {
      if (var1.id == 401 && var1.target.equals(this.field_1)) {
         this.dframe.toggle();
         if (!this.dframe.isDetached() && !this.dframe.isDetached() && this.pagedestroyed) {
            System.out.println("disposing, PAGE GONE!!");
            this.dframe.dispose();
         }
      }

      return super.handleEvent(var1);
   }

   public String pad(int var1) {
      String var2 = "0" + var1;
      return var2.substring(var2.length() - 2, var2.length());
   }
}
