import java.applet.Applet;
import java.applet.AudioClip;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.io.DataInputStream;
import java.io.FilterInputStream;
import java.net.URL;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.Vector;

public class Typewriter4 extends Applet implements Runnable {
   // $FF: renamed from: as AppletSettings
   AppletSettings field_0;
   AudioClip hit;
   // $FF: renamed from: cr java.applet.AudioClip
   AudioClip field_1;
   AudioClip ding;
   boolean alreadyrung = false;
   boolean badconfigure = false;
   boolean soundon = false;
   boolean loop = true;
   Color bgcolor;
   Color textcolor;
   // $FF: renamed from: f java.awt.Font
   Font field_2;
   Graphics bufferG;
   Image bufferI;
   Image background;
   // $FF: renamed from: w int
   int field_3;
   // $FF: renamed from: h int
   int field_4;
   int fontstyle;
   int fontsize;
   int wordcount;
   int currentline;
   int currentword;
   int currentletter;
   int depth;
   int margin;
   int cycles;
   int step;
   int pause;
   int totalwords;
   int speed;
   int update;
   int linecount;
   long lastread;
   // $FF: renamed from: mt java.awt.MediaTracker
   MediaTracker field_5;
   String[] words;
   String soundactivation = "enter";
   String text;
   String text2;
   String fontname;
   String dimensions;
   String border;
   String param;
   String textfile;
   String sounddir;
   String target;
   Thread woohoo;
   URL hotlink;
   Vector lines;

   public void init() {
      this.field_0 = new AppletSettings(this);
      this.field_5 = new MediaTracker(this);
      this.lastread = 0L;
      Dimension var1 = ((Component)this).size();
      this.field_3 = var1.width;
      this.field_4 = var1.height;
      this.bufferI = ((Component)this).createImage(this.field_3, this.field_4);
      this.bufferG = this.bufferI.getGraphics();
      this.param = ((Applet)this).getParameter("COPYRIGHT");
      if (this.param == null || !this.param.equals("Typewriter applet, Copyright 1996 Sun Microsystems, Inc., all rights reserved.")) {
         this.badconfigure = true;
      }

      this.param = ((Applet)this).getParameter("DOCUMENTATION");
      if (this.param == null || !this.param.equals("Documentation found at: http://www.xm.com/cafe/")) {
         this.badconfigure = true;
      }

      this.param = ((Applet)this).getParameter("BACKGROUND");
      if (this.param != null) {
         try {
            this.background = ((Applet)this).getImage(new URL(((Applet)this).getDocumentBase(), this.param));
         } catch (Exception var8) {
         }

         if (this.background != null) {
            this.field_5.addImage(this.background, 0);
         }
      }

      this.bgcolor = this.field_0.bgcolor;
      this.textcolor = this.field_0.textcolor;
      this.fontname = this.field_0.fontname;
      this.fontsize = this.field_0.fontsize;
      this.fontstyle = this.field_0.fontstyle;
      this.param = ((Applet)this).getParameter("BORDER");
      this.border = this.param != null ? this.param.toLowerCase() : "none";
      this.param = ((Applet)this).getParameter("CYCLES");
      if (this.param != null && !this.param.equalsIgnoreCase("infinite")) {
         this.cycles = Integer.parseInt(this.param);
         this.step = 1;
      } else {
         this.cycles = 1;
         this.step = 0;
      }

      this.param = ((Applet)this).getParameter("MARGIN");
      this.margin = this.param != null ? Integer.parseInt(this.param) : this.field_3 / 10;
      this.param = ((Applet)this).getParameter("PAUSE");
      this.pause = this.param != null ? Integer.parseInt(this.param) : 2000;
      this.param = ((Applet)this).getParameter("SOUNDACTIVATION");
      this.soundactivation = this.param != null ? this.param.toLowerCase() : "enter";
      this.soundon = this.soundactivation.equals("auto");
      this.param = ((Applet)this).getParameter("SOUND.KEYSTROKE");
      if (this.param != null) {
         try {
            this.hit = ((Applet)this).getAudioClip(new URL(((Applet)this).getDocumentBase(), this.param));
         } catch (Exception var7) {
         }
      }

      this.param = ((Applet)this).getParameter("SOUND.RETURN");
      if (this.param != null) {
         try {
            this.field_1 = ((Applet)this).getAudioClip(new URL(((Applet)this).getDocumentBase(), this.param));
         } catch (Exception var6) {
         }
      }

      this.param = ((Applet)this).getParameter("SOUND.BELL");
      if (this.param != null) {
         try {
            this.ding = ((Applet)this).getAudioClip(new URL(((Applet)this).getDocumentBase(), this.param));
         } catch (Exception var5) {
         }
      }

      this.param = ((Applet)this).getParameter("SPEED");
      this.speed = this.param != null ? Math.max(10, Integer.parseInt(this.param)) : 100;
      this.param = ((Applet)this).getParameter("TARGET");
      this.target = this.param != null ? this.param : "_self";
      this.param = ((Applet)this).getParameter("URL");
      if (this.param != null) {
         try {
            this.hotlink = new URL(((Applet)this).getDocumentBase(), this.param);
         } catch (Exception var4) {
         }
      } else {
         try {
            this.hotlink = new URL("http://www.xm.com/cafe/Typewriter/index.html");
         } catch (Exception var3) {
         }
      }

      this.param = ((Applet)this).getParameter("TEXT");
      this.text = this.param != null ? this.param : "This is a test... this is only a test... if this had been an actual emergency, you would have been given instructions on where to go and what to do.\nHey!... Put your own text in...";
      this.text = this.text.replace('\\', '\n');
      this.param = ((Applet)this).getParameter("TEXTFILE");
      this.textfile = this.param != null ? this.param : null;
      this.param = ((Applet)this).getParameter("UPDATE");
      this.update = this.param != null ? Integer.parseInt(this.param) : 15;
      this.field_2 = new Font(this.fontname, this.fontstyle, this.fontsize);
      this.buildLines();

      try {
         this.field_5.waitForID(0);
      } catch (InterruptedException var2) {
      }
   }

   public void run() {
      this.currentline = 0;

      for(int var1 = 0; var1 < this.cycles; var1 += this.step) {
         long var2 = new Long((new Date()).getTime());
         if (var2 - this.lastread > (long)(this.update * '\uea60') && this.textfile != null) {
            this.checkTextfile();
            this.buildLines();
         }

         for(int var4 = 0; var4 < this.linecount; ++var4) {
            this.currentletter = 1;
            String var5 = (String)this.lines.elementAt(var4);

            for(int var6 = 0; var6 < var5.length(); ++var6) {
               if (this.soundon && this.hit != null) {
                  this.hit.play();
               }

               if (var6 == var5.length() && this.soundon && this.field_1 != null) {
                  this.field_1.play();
               }

               ((Component)this).repaint();
               int var7 = 75 + (int)(Math.random() * (double)100.0F);

               try {
                  Thread.sleep((long)(var7 * this.speed / 100));
               } catch (InterruptedException var10) {
                  System.out.println("BB: " + ((Throwable)var10).toString());
               }

               ++this.currentletter;
            }

            this.currentletter = 0;
            ++this.currentline;
            this.alreadyrung = false;
         }

         this.currentline %= this.linecount;

         try {
            Thread.sleep((long)this.pause);
         } catch (InterruptedException var9) {
            System.out.println("AA: " + ((Throwable)var9).toString());
         }
      }

   }

   public void paintBuffer(Graphics var1) {
      if (this.background != null) {
         var1.drawImage(this.background, 0, 0, this);
      } else {
         var1.setColor(this.bgcolor);
         if (this.border.equals("in")) {
            var1.fill3DRect(0, 0, this.field_3, this.field_4, false);
         } else if (this.border.equals("out")) {
            var1.fill3DRect(0, 0, this.field_3, this.field_4, true);
         } else {
            var1.fillRect(0, 0, this.field_3, this.field_4);
         }
      }

      var1.setColor(this.textcolor);
      var1.setFont(this.field_2);
      FontMetrics var2 = var1.getFontMetrics();

      for(int var3 = 0; var3 < this.currentline; ++var3) {
         var1.drawString((String)this.lines.elementAt(this.currentline - var3 - 1), this.margin, this.depth - (var3 + 1) * var2.getHeight());
      }

      String var4 = (String)this.lines.elementAt(this.currentline);
      String var5 = this.currentletter < var4.length() ? var4.substring(0, this.currentletter) : var4;
      if (var2.stringWidth(var5) > 8 * this.field_3 / 10 && !this.alreadyrung && this.soundon) {
         this.alreadyrung = true;
         if (this.ding != null) {
            this.ding.play();
         }
      }

      var1.drawString(var5, this.margin, this.depth);
   }

   public void paint(Graphics var1) {
      this.paintBuffer(this.bufferG);
      var1.drawImage(this.bufferI, 0, 0, this);
   }

   public void update(Graphics var1) {
      this.paint(var1);
   }

   public void start() {
      if (this.woohoo == null) {
         this.woohoo = new Thread(this);
         if (!this.badconfigure) {
            this.woohoo.start();
         }
      }

   }

   public void stop() {
      this.woohoo.stop();
      this.woohoo = null;
   }

   public void destroy() {
      this.bufferG.dispose();
   }

   public boolean mouseEnter(Event var1, int var2, int var3) {
      if (this.hotlink != null) {
         ((Applet)this).showStatus("LINK TO: " + this.hotlink.toString());
      }

      if (this.soundactivation.equals("enter")) {
         this.soundon = true;
      }

      return true;
   }

   public boolean mouseExit(Event var1, int var2, int var3) {
      if (this.soundactivation.equals("enter")) {
         this.soundon = false;
      }

      return true;
   }

   public boolean mouseDown(Event var1, int var2, int var3) {
      try {
         ((Applet)this).getAppletContext().showDocument(this.hotlink, this.target);
      } catch (Exception var4) {
      }

      return true;
   }

   public void buildLines() {
      this.lines = new Vector();
      Font var1 = new Font(this.fontname, this.fontstyle, this.fontsize);
      Image var3 = ((Component)this).createImage(this.field_3, this.field_4);
      Graphics var2 = var3.getGraphics();
      var2.setFont(var1);
      FontMetrics var4 = var2.getFontMetrics();

      for(StringTokenizer var5 = new StringTokenizer(this.text, "\n"); var5.hasMoreTokens(); this.linecount = this.lines.size()) {
         String var6 = "";
         StringTokenizer var7 = new StringTokenizer(var5.nextToken());
         this.wordcount = var7.countTokens();
         this.totalwords += this.wordcount;
         this.words = new String[this.wordcount];

         for(int var8 = 0; var8 < this.wordcount; ++var8) {
            this.words[var8] = var7.nextToken();
         }

         for(int var9 = 0; var9 < this.wordcount; ++var9) {
            var6 = var6 == null ? this.words[0] : var6 + this.words[var9] + " ";
            if (var4.stringWidth(var6) > this.field_3 - this.margin * 2) {
               this.lines.addElement(var6.substring(0, var6.lastIndexOf(" ", var6.lastIndexOf(" ") - 1)));
               var6 = this.words[var9] + " ";
            }
         }

         this.lines.addElement(var6);
      }

      this.depth = this.field_4 - var4.getHeight() / 2;
      var2.dispose();
   }

   public void checkTextfile() {
      this.loop = true;
      this.text = "";

      try {
         DataInputStream var1 = new DataInputStream((new URL(((Applet)this).getDocumentBase(), this.textfile)).openStream());
         boolean var2 = true;

         while(var2) {
            String var3 = var1.readLine();
            if (var3 == null) {
               var2 = false;
            } else {
               this.text = this.text + var3 + "\n";
            }
         }

         ((FilterInputStream)var1).close();
         this.lastread = new Long((new Date()).getTime());
      } catch (Exception var4) {
         System.out.println("OOOHH--" + ((Throwable)var4).toString());
      }
   }
}
